diff --git a/debian/control b/debian/control
index b84a0c2f..c5f841d9 100644
--- a/debian/control
+++ b/debian/control
@@ -35,6 +35,7 @@ Depends: ${python:Depends},
     python-pyexcel-ods,
     python-pyexcel-xls,
     python-crypto,
+    python-pycryptodome,
     python-feedparser,
     python-pdfrw,
     python-httplib2,
diff --git a/passerelle/apps/cryptor/migrations/0001_initial.py b/passerelle/apps/cryptor/migrations/0001_initial.py
index ac6acf37..dd390490 100644
--- a/passerelle/apps/cryptor/migrations/0001_initial.py
+++ b/passerelle/apps/cryptor/migrations/0001_initial.py
@@ -1,5 +1,5 @@
 # -*- coding: utf-8 -*-
-# Generated by Django 1.11.18 on 2020-02-21 14:54
+# Generated by Django 1.11.18 on 2020-03-04 10:25
 from __future__ import unicode_literals
 
 from django.db import migrations, models
@@ -33,13 +33,13 @@ class Migration(migrations.Migration):
                 ('title', models.CharField(max_length=50, verbose_name='Title')),
                 ('slug', models.SlugField(unique=True, verbose_name='Identifier')),
                 ('description', models.TextField(verbose_name='Description')),
-                ('public_key', models.TextField(blank=True, validators=[passerelle.apps.cryptor.models.validate_rsa_key], verbose_name='Encrypt RSA public key (PEM format)')),
-                ('private_key', models.TextField(blank=True, validators=[passerelle.apps.cryptor.models.validate_rsa_key], verbose_name='Decrypt RSA private key (PEM format)')),
+                ('public_key', models.TextField(blank=True, validators=[passerelle.apps.cryptor.models.validate_rsa_key], verbose_name='Encryption RSA public key (PEM format)')),
+                ('private_key', models.TextField(blank=True, validators=[passerelle.apps.cryptor.models.validate_rsa_key], verbose_name='Decryption RSA private key (PEM format)')),
                 ('redirect_url_base', models.URLField(blank=True, help_text='Base URL for redirect, empty for local', max_length=256, verbose_name='Base URL of decrypt system')),
                 ('users', models.ManyToManyField(blank=True, related_name='_cryptor_users_+', related_query_name='+', to='base.ApiUser')),
             ],
             options={
-                'verbose_name': 'Encryption and Decryption',
+                'verbose_name': 'Encryption / Decryption',
             },
         ),
         migrations.AddField(
diff --git a/passerelle/apps/cryptor/models.py b/passerelle/apps/cryptor/models.py
index 8b2b89c6..63ce6729 100644
--- a/passerelle/apps/cryptor/models.py
+++ b/passerelle/apps/cryptor/models.py
@@ -14,12 +14,10 @@
 # You should have received a copy of the GNU Affero General Public License
 # along with this program.  If not, see <http://www.gnu.org/licenses/>.
 
-import contextlib
 import base64
 import binascii
 import json
 import os
-import tempfile
 from uuid import uuid4
 
 from Cryptodome.PublicKey import RSA
@@ -117,10 +115,10 @@ def validate_rsa_key(key):
 
 class Cryptor(BaseResource):
     public_key = models.TextField(blank=True,
-                                  verbose_name=_('Encrypt RSA public key (PEM format)'),
+                                  verbose_name=_('Encryption RSA public key (PEM format)'),
                                   validators=[validate_rsa_key])
     private_key = models.TextField(blank=True,
-                                   verbose_name=_('Decrypt RSA private key (PEM format)'),
+                                   verbose_name=_('Decryption RSA private key (PEM format)'),
                                    validators=[validate_rsa_key])
     redirect_url_base = models.URLField(max_length=256, blank=True,
                                         verbose_name=_('Base URL of decrypt system'),
@@ -129,7 +127,7 @@ class Cryptor(BaseResource):
     category = _('Misc')
 
     class Meta:
-        verbose_name = _('Encrypt / Decrypt')
+        verbose_name = _('Encryption / Decryption')
 
     def get_redirect_url_base_display(self):
         if self.redirect_url_base:
@@ -164,7 +162,7 @@ class Cryptor(BaseResource):
         cfile = CryptedFile(resource=self, filename=filename, content_type=content_type)
         cfile.save()
 
-        uuid = str(cfile.uuid)
+        uuid = str(cfile.uuid)  # get string representation of UUID object
 
         if self.redirect_url_base:
             redirect_url_base = self.redirect_url_base
diff --git a/passerelle/static/css/style.css b/passerelle/static/css/style.css
index d4d367e6..d6c9672d 100644
--- a/passerelle/static/css/style.css
+++ b/passerelle/static/css/style.css
@@ -177,6 +177,10 @@ li.connector.dpark a::before {
 	content: "\f1b9";  /* car */
 }
 
+li.connector.cryptor a::before {
+	content: "\f023";  /* lock */
+}
+
 li.connector.status-down span.connector-name::after {
 	font-family: FontAwesome;
 	content: "\f00d"; /* times */